
rm(list = ls())
library(reticulate)
library(PoiClaClu)
library(sSeq)
library(limma)
library(edgeR)
setwd("G:/code")
source("ZINBL.r")
use_python("F:/python/Anaconda3/python.exe",required = T)
py_config()
py_available()
py_module_available("tensorflow")
source_python("ZINB.py")

X_train<- data.matrix(read.csv("./dataset/realdata_xtr.csv", header = FALSE))
X_test<-data.matrix(read.csv("./dataset/realdata_xte.csv", header = FALSE))
y_train<-data.matrix(read.csv("./dataset/realdata_ytr.csv", header = FALSE))
y_test<-data.matrix(read.csv("./dataset/realdata_yte.csv", header = FALSE))
dat<-list(x=X_train,y=y_train,xte=X_test,yte=y_test)
top=500
dat<-select3(dat,top)
n<-length(dat$yte)
batch_size<-as.integer(128)
predict <- ZINBScore(dat=dat,batch_size=batch_size)
DeepZInb2 = length(which((predict$y_test)!=(predict$y_pre)))
mis = DeepZInb2 / length(dat$yte)
print("Misclassification of DeepZINB:")
print(mis)

